pt2en		equ	TRISC2
eeclk		equ	2
eedata	equ	3
ptclkem	equ	pt2en     ; 0 input  , 1 output
ptdaem	equ	pt2en
ptda		equ	pt2
ptclk		equ	pt2
;======================================================
; [0x100]  --> eeaddress 
; [0x101]  --> s_reg_EE
; [0x102]  --> fsr0H
; [0x103]  --> fsr0L
;SPIRWEE:
;       MVFFS      100h,eeaddress
;       MVFFS      101h,s_reg_EE
;       MVFFS      102h,FSR0H
;       MVFFS      103h,FSR0L
;       mvf       FSR0L,W,ACCE
;       btss      RSTX,b_rdEEPROM,ACCE
;       jmp       eewrblk
;       jmp       eerdblk
;======================================================
; eecnt is chip select , work registor eeprom's is address
; eedatemp is data
eeread:
        mvf      eeaddress,F,ACCE
        mvl      1
        mvf      s_reg_EE,F,ACCE
;        mvl      HIGH  eedatemp
;        mvf      fsr0H,F,ACCE
        mvl      eedatemp
;=========================================================================
;eecnt  is chip select or extra eeprom address
;@eeaddress is eeprom address
;Work registor is data address
;@s_reg_EE is lenght
;chip select is eecnt
;if c=1 then I2C Error
eerdblk:
        mvf      fsr0L,F,ACCE
eerdblk_a:
        call     eerdblk_Bg
        btsz     WREG,0,ACCE
        ret
        call     eestart_r
        btsz     WREG,0,ACCE
        ret
    eerdblk_d:    
        call     eerddata
        mvf      INDF0,F,ACCE
        INF	  	FSR0L,F,Acce
        insz     eeaddress,f,ACCE
        JMP     eerdblk_b
        dcsz    s_reg_EE,f,ACCE
        jmp     eerdblk_c
        jmp     eerdblk_end
  eerdblk_c: 
        call     EERdblk_Page    
        jmp     eerdblk_a
  eerdblk_b:
        dcsz     s_reg_EE,f,ACCE
        jmp      eerdblk_e
        jmp      eerdblk_end
   eerdblk_e:     
        call     eehasack
        jmp      eerdblk_d
        
   eerdblk_end:
        call     eenoack
        ;bcf     status,c,ACCE
        retl     0
;----------------------------
; Head of EEProm
EERdblk_Bg:        
        clrf     temr,ACCE
        clrf     r_Len_EE,ACCE
        call     eestart
        btsz     WREG,0,ACCE
        jmp      eeprom_err
      ;--------------------  
        mvf    eeaddress,W,ACCE
        jmp     eedevice
;--------------------------      
EERdblk_Page:       
        call     eenoack
 EEPage_COM:       
        mvl      00000010b 
        addf     eecnt,w,ACCE
        andl     00001111b
        mvf      FSR1L,F,ACCE
        mvl      11110000b
        andf     eecnt,f,ACCE
        mvf      FSR1L,W,ACCE
        iorf     eecnt,f,ACCE
        ret
;----------------------------
;================================================================
; if eeprom error then w = 1 
eeprom_err:
        CALL     eeclkhi
        call     eedatahi
        retl      1
;======================================================
; eecnt is chip select , work registor eeprom's is address
; eedatemp is data
eewrite:
        mvf      eeaddress,F,ACCE
        mvl      1
        mvf      s_reg_EE,F,ACCE
        mvl      HIGH eedatemp
;        mvf      FSR0H,F,ACCE
;        mvl      eedatemp
;=========================================================================
;@eeaddress is eeprom address
;@Work registor is data address
;@s_reg_EE is lenght
;chip select is eecnt
eewrblk:
        mvf      fsr0L,F,ACCE
eewrblk_a:
        call     EERdblk_Bg
        btsz     WREG,0,ACCE
        jmp      eeprom_err
  eewrblk_c:     
        mvf      INDF0,W,ACCE
        INF		FSR0L,F,Acce
        call     eedevice
        btsz     WREG,0,ACCE
        JMP      eeprom_err
        ;inf      fsr0,f
        insz     eeaddress,f,ACCE
        jmp      eewrblk_b
        jmp      eewrblk_e
    eewrblk_b:    
        dcsz     s_reg_EE,f,ACCE
        jmp      eewrblk_m
        jmp      eewrblk_end
    eewrblk_m:         
        mvf      eeaddress,W,ACCE
        andl     00000111b
        btss     status,z,ACCE

        jmp      eewrblk_c
        call     eestop
        call     delay10ms
        jmp      eewrblk_a
    eewrblk_end:     
        call     eestop
        call     delay10ms
        retl     0
    eewrblk_e:
        dcsz     s_reg_EE,f,ACCE
        jmp      eewrblk_f
        jmp      eewrblk_end
   eewrblk_f:
        call     eestop
        call     EEPage_COM
        call     delay10ms
        jmp      eewrblk_a      
;====================================================================
eestart:
        call     eeclkhi
        call     eedatahi
        mvf      eecnt,W,ACCE
        andl     11111110b
        jmp      eestart_w
eestart_r:
        call     eeclklow
        call     eeclkhi
        call     eedatahi
        mvf      eecnt,W,ACCE
        iorl     00000001b
        jmp      eestart_w
eestart_w:
        call     eedatalow
        jmp      eedevice
;-------------------------------
; work registor is device ID
eedevice:
        bsf      r_Len_EE,3,ACCE
eedevice_c:
        call     eeclklow      ; clock low data prepare
        rlfc     WREG,f,ACCE
        btss     status,c,ACCE
        jmp      eedevice_a
        call     eedatahi
        jmp      eedevice_b
eedevice_a:
        call     eedatalow
eedevice_b:
        call     eeclkhi       ; clock hi data write in
        dcsz     r_Len_EE,f,ACCE
        jmp      eedevice_c
        jmp      eeack_wait
;-------------------------------
eeack_wait:
        nop
        call     eeclklow       ; 8's clk low
        call     eedatahi       ; for ee
        call     eeclkhi        ; clock high
        clrf     temr,ACCE
        mvl      0
eeack_wait_a:
        btss     ptda,eedata,ACCE
        jmp      eeack_wait_b
        dcsz     temr,f,ACCE
        jmp      eeack_wait_a
        mvl      1
        jmp      eeack_wait_ed
eeack_wait_b:
        clrf     temr,ACCE
   eeack_wait_d:     
        btsz     ptclk,eeclk,ACCE
        jmp      eeack_wait_ed
        dcsz     temr,f,ACCE
        jmp      eeack_wait_d 
        mvl      1
eeack_wait_ed:  
        call     eeclklow
        ret
;-----------------------------------
; Work Registor is data
eerddata:
        call     eeclklow
        bsf      r_Len_EE,3,ACCE
eerddata_a:        
        call     eeclklow
        mvl      0
        btsz     ptda,eedata,ACCE
        mvl      1
        rrfc     WREG,F,ACCE   ; set c
        rlfc     temr,f,ACCE
        call     eeclkhi
        dcsz     r_Len_EE,f,ACCE
        jmp      eerddata_a
        mvf      temr,W,ACCE
        ret
;--------------------
eehasack:
        call     eeclklow
        call     eedatalow
        call     eeclkhi
        call     eeclklow
        jmp      eedatahi
;--------------------------        
eenoack:
        call     eeclklow
        call     eedatahi
        call     eeclkhi
        jmp      eestop
;----------------------------------
eestop:
        call     eeclklow
        call     eedatalow
        nop
        call     eeclkhi
        jmp      eedatahi
;=============================
eeclklow:
        bcf      PT2PU,eeclk,acce
        bsf      ptclkem,eeclk,ACCE
        bcf      ptclk,eeclk,ACCE
        ret
eeclkhi:
        bcf      ptclkem,eeclk,ACCE
        bsf      PT2PU,eeclk,acce
        ret
eedatalow:
        bcf      PT2PU,eedata,acce
        bsf      ptdaem,eedata,ACCE
        bcf      ptda,eedata,ACCE
        ret
eedatahi:
        bsf      PT2PU,eedata,acce
        bcf      ptdaem,eedata,ACCE
        ret
;==========================================



